module UHC.Light.Compiler.Base.UnderDev
( UnderDev (..), allUnderDevMp )
where
import UHC.Util.Utils
import qualified Data.Map as Map
import UHC.Light.Compiler.Base.Common

{-# LINE 31 "src/ehc/Base/UnderDev.chs" #-}
-- | Topics under development
data UnderDev
  = UnderDev_Anon					-- something under development not further specified
  | UnderDev_NameAnalysis			-- alternate (more accurate) name dependency analysis, required for named instances
  | UnderDev_NamedInst				-- newer syntax for naming instances
  deriving (Eq,Ord,Enum,Typeable,Bounded,Generic)

instance DataAndConName UnderDev

instance Show UnderDev where
  show = strToLower . showUnprefixed 1

allUnderDevMp :: Map.Map String UnderDev
allUnderDevMp = str2stMp

