module UHC.Light.Compiler.CodeGen.ImportUsedModules
( ImportUsedModules (..), emptyImportUsedModules )
where
import UHC.Light.Compiler.Base.Common
import qualified Data.Set as Set

{-# LINE 18 "src/ehc/CodeGen/ImportUsedModules.chs" #-}
data ImportUsedModules
  = ImportUsedModules
      { iumSrcDeclModules		:: !HsNameS			-- ^ imported modules as declared in src .hs
      , iumHIDeclModules		:: !HsNameS			-- ^ imported modules as declared, either in .hs or .hi
      , iumHIUsedModules		:: !HsNameS			-- ^ imported modules as actually used
      , iumIntrodModules		:: !HsNameS			-- ^ module names for which a introduction/def is made
      }

emptyImportUsedModules = ImportUsedModules Set.empty Set.empty Set.empty Set.empty

