module UHC.Light.Compiler.CodeGen.ModuleImportExportImpl
( ModuleImportExportImpl (..), emptyModuleImportExportImpl )
where
import UHC.Light.Compiler.Base.Common
import UHC.Light.Compiler.LamInfo
import UHC.Light.Compiler.CodeGen.ValAccess
import qualified Data.Map as Map

{-# LINE 22 "src/ehc/CodeGen/ModuleImportExportImpl.chs" #-}
data ModuleImportExportImpl
  = ModuleImportExportImpl
      { mieimplLamMp			:: LamMp			-- ^ LamMp, per binding info
      , mieimplUsedModNmL		:: [HsName]			-- ^ used and referred to modules (i.e. all, also indirectly referred to)
      , mieimplHsName2FldMpMp	:: HsName2FldMpMp	-- ^ imported modules fld mp
      , mieimplHsName2FldMp		:: HsName2FldMp		-- ^ export fld map
      }
  deriving (Typeable)

emptyModuleImportExportImpl = ModuleImportExportImpl Map.empty [] Map.empty Map.empty

