{-# LINE 2 "src/ehc/CoreRun/API/Internal.chs" #-}
-- | CoreRun Internal API
--
-- Intended for implementing stuff that has to know about internals (i.e. class instances).
--
-- See CoreRun.API.
--
-- To do (currently sorely missing):
--   proper/enough primitives, and doc for them.
--

module UHC.Light.Compiler.CoreRun.API.Internal
  (
  -- * CoreRun AST
  -- | The datatypes making up a CoreRun program, with constructors
    AGItf(..)
  , Mod(..)
  , Exp(..)
  , SExp(..)
  , Alt(..)
  , Pat(..)
  , DataCon(..)
  , Import(..)
  , Meta(..)
  , RRef(..)

  -- * Utilities
  , crarrayFromList
  , crarrayToList

  -- * Re-export
  , module UHC.Light.Compiler.CoreRun.API
  )
  where

import UHC.Light.Compiler.CoreRun.API
-- import UHC.Light.Compiler.CoreRun.Prim as CR
import UHC.Light.Compiler.CoreRun as CR
import UHC.Light.Compiler.CoreRun.Run as CR hiding(Alt)


