module UHC.Light.Compiler.Gam.KiGam
( KiGam, KiGamInfo (..)
, initKiGam )
where
import UHC.Util.Pretty
import UHC.Util.Utils
import UHC.Light.Compiler.Base.Common
import UHC.Light.Compiler.Base.TermLike
import UHC.Light.Compiler.Base.HsName.Builtin
import UHC.Light.Compiler.Ty
import UHC.Light.Compiler.Ty.Pretty
import UHC.Light.Compiler.Gam
import UHC.Light.Compiler.Error
import qualified Data.Set as Set
import UHC.Light.Compiler.VarMp
import UHC.Light.Compiler.Substitutable
import UHC.Light.Compiler.Ty.Trf.Quantify






{-# LINE 37 "src/ehc/Gam/KiGam.chs" #-}
-- If this changes, also change {%{EH}ConfigInternalVersions}
data KiGamInfo
  = KiGamInfo
      { kgiKi :: Ty }
      deriving Show

type KiGam = Gam HsName KiGamInfo

{-# LINE 53 "src/ehc/Gam/KiGam.chs" #-}
initKiGam :: KiGam
initKiGam
  = assocLToGam
      [ (hsnArrow   ,   KiGamInfo (appCon hsnArrow))
      , (hsnKindStar,   KiGamInfo kiStar)
      , (hsnKindRow ,   KiGamInfo kiRow)
      ]

